<template>
    <div class="address">
        <v-row
            :class="[
                { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
            ]"
        >
            <v-col v-if="$vuetify.breakpoint.mdAndUp" cols="3">
                <menu-bar />
            </v-col>
            <v-col>
                <v-row
                    :class="[
                        { 'pt-16 pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col>
                        <h1 class="font-syne-bold">
                            {{ $t('dashboard.menu.ADDRESSEDIT') }}
                        </h1>
                        <v-breadcrumbs
                            ><v-breadcrumbs-item
                                class="text-red pointer"
                                @click="goToPage(menus.ADDRESS.id)"
                                >{{
                                    $t('dashboard.menu.ADDRESS')
                                }}</v-breadcrumbs-item
                            ><v-breadcrumbs-divider>/</v-breadcrumbs-divider>
                            <v-breadcrumbs-item disabled>{{
                                $t('dashboard.menu.ADDRESSEDIT') +
                                ' ' +
                                selectedAddress
                            }}</v-breadcrumbs-item></v-breadcrumbs
                        >
                    </v-col>
                </v-row>
                <v-form
                    v-show="pageLoaded"
                    ref="addressForm"
                    lazy-validation
                    @submit.prevent
                >
                    <v-row
                        :class="[
                            { 'pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                            {
                                'pb-16 pl-16 pr-16':
                                    $vuetify.breakpoint.mdAndUp,
                            },
                        ]"
                    >
                        <v-col cols="12">
                            <!-- EDIT ADDRESS FORM -->
                            <v-row>
                                <v-col cols="6" class="form-field"
                                    ><!-- FIRST NAME -->
                                    <v-text-field
                                        ref="name"
                                        v-model="form.firstName.value"
                                        :label="$t('form.firstName.text')"
                                        :placeholder="
                                            $t('form.firstName.placeholder')
                                        "
                                        solo
                                        required
                                        :rules="[requiredRules]"
                                    ></v-text-field
                                ></v-col>
                                <v-col cols="6" class="form-field"
                                    ><!-- LAST NAME -->
                                    <v-text-field
                                        ref="name"
                                        v-model="form.lastName.value"
                                        :label="$t('form.lastName.text')"
                                        :placeholder="
                                            $t('form.lastName.placeholder')
                                        "
                                        solo
                                        required
                                        :rules="[requiredRules]"
                                    ></v-text-field
                                ></v-col>
                            </v-row>
                            <v-row>
                                <v-col cols="6" class="form-field"
                                    ><!-- MOBILE -->
                                    <v-text-field
                                        ref="mobile"
                                        v-model="form.mobile.value"
                                        :label="$t('form.mobile.text')"
                                        :placeholder="
                                            $t('form.mobile.placeholder')
                                        "
                                        solo
                                        required
                                        :rules="[requiredRules]"
                                    ></v-text-field
                                ></v-col>
                                <v-col cols="6" class="form-field"
                                    ><!-- COMPANY -->
                                    <v-text-field
                                        ref="company"
                                        v-model="form.company.value"
                                        :label="$t('form.company.text')"
                                        :placeholder="
                                            $t('form.company.placeholder')
                                        "
                                        solo
                                    ></v-text-field
                                ></v-col>
                            </v-row>
                            <v-row>
                                <v-col cols="12" class="form-field"
                                    ><!-- ADDRESS 1 -->
                                    <v-text-field
                                        ref="address1"
                                        v-model="form.address1.value"
                                        :label="$t('form.address1.text')"
                                        :placeholder="
                                            $t('form.address1.placeholder')
                                        "
                                        solo
                                        :rules="[requiredRules]"
                                    ></v-text-field
                                ></v-col>
                            </v-row>
                            <v-row>
                                <v-col cols="12" class="form-field"
                                    ><!-- ADDRESS 2 -->
                                    <v-text-field
                                        ref="address2"
                                        v-model="form.address2.value"
                                        :label="$t('form.address2.text')"
                                        :placeholder="
                                            $t('form.address2.placeholder')
                                        "
                                        solo
                                    ></v-text-field
                                ></v-col>
                            </v-row>
                            <v-row>
                                <v-col cols="6" class="form-field"
                                    ><!-- CITY -->
                                    <v-text-field
                                        ref="city"
                                        v-model="form.city.value"
                                        :label="$t('form.city.text')"
                                        :placeholder="
                                            $t('form.city.placeholder')
                                        "
                                        solo
                                        :rules="[requiredRules]"
                                    ></v-text-field
                                ></v-col>
                                <v-col cols="6" class="form-field"
                                    ><!-- STATE -->
                                    <v-text-field
                                        ref="state"
                                        v-model="form.state.value"
                                        :label="$t('form.state.text')"
                                        :placeholder="
                                            $t('form.state.placeholder')
                                        "
                                        solo
                                        :rules="[requiredRules]"
                                    ></v-text-field
                                ></v-col>
                            </v-row>
                            <v-row>
                                <v-col cols="6" class="form-field"
                                    ><!-- POSTCODE -->
                                    <v-text-field
                                        ref="postcode"
                                        v-model="form.postcode.value"
                                        :label="$t('form.postcode.text')"
                                        :placeholder="
                                            $t('form.postcode.placeholder')
                                        "
                                        solo
                                        :rules="[requiredRules]"
                                    ></v-text-field
                                ></v-col>
                                <v-col cols="6" class="form-field"
                                    ><!-- COUNTRY -->
                                    <v-select
                                        ref="country"
                                        v-model="form.country.value"
                                        :label="$t('form.country.text')"
                                        :items="countryList"
                                        solo
                                        required
                                        :rules="[requiredRules]"
                                    ></v-select
                                ></v-col>
                            </v-row>
                            <!-- SUBMIT BUTTON -->
                            <v-row>
                                <v-col>
                                    <v-btn
                                        :block="$vuetify.breakpoint.smAndDown"
                                        class="lowercase br-0 pl-10 pr-10 font-syne-bold"
                                        color="badge"
                                        :disabled="isAddAddressBtnDisabled"
                                        :loading="isAddAddressBtnDisabled"
                                        @click="validateForm"
                                        >{{ $t('buttons.saveBtn') }}</v-btn
                                    >
                                </v-col>
                            </v-row>
                        </v-col>
                    </v-row>
                </v-form>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'

@Component<any>({
    middleware: ['authenticate'],
    head() {
        return {
            titleTemplate: '%s | ' + this.$t('dashboard.menu.HOME'),
            title:
                this.$t('dashboard.menu.ADDRESSEDIT') +
                ' #' +
                this.selectedAddress,
            meta: [
                {
                    hid: 'description',
                    name: 'description',
                    content: this.productDescription,
                },
            ],
        }
    },
    computed: mapGetters({
        menus: 'menu/getMenuDashboard',
        getAddress: 'user/getEditAddress',
    }),
})
export default class AddressEdit extends Vue {
    // Data
    $refs!: { addressForm: HTMLFormElement }
    ref: any = this.$refs
    pageLoaded: boolean = false
    menus!: any
    getAddress!: any
    selectedPage: Number = 2 // address
    selectedAddress: Number = 1 // default address
    isAddAddressBtnDisabled: Boolean = false
    formHasErrors: Boolean = false
    form: { [key: string]: any } = {
        firstName: {
            value: '',
            error: null,
            requestKey: 'first_name',
        },
        lastName: {
            value: '',
            error: null,
            requestKey: 'last_name',
        },
        mobile: {
            value: '',
            error: null,
            requestKey: 'mobile',
        },
        company: {
            value: '',
            error: null,
            requestKey: 'company',
        },
        address1: {
            value: '',
            error: null,
            requestKey: 'address_1',
        },
        address2: {
            value: '',
            error: null,
            requestKey: 'address_2',
        },
        city: {
            value: '',
            error: null,
            requestKey: 'city',
        },
        state: {
            value: '',
            error: null,
            requestKey: 'state',
        },
        country: {
            value: '',
            error: null,
            requestKey: 'country',
        },
        postcode: {
            value: '',
            error: null,
            requestKey: 'postcode',
        },
    }

    countryList: any = ['Malaysia']

    // Methods
    validateForm() {
        if (typeof this.$refs === 'undefined') {
            return
        }

        setTimeout(() => {
            const valid = this.$refs.addressForm.validate()

            if (valid) {
                this.submit()
            }
        }, 300)
    }

    submit() {
        this.isAddAddressBtnDisabled = true
        this.$api.user
            .updateAddress(
                this.getAddress.id,
                this.form.firstName.value,
                this.form.lastName.value,
                this.form.mobile.value,
                this.form.company.value,
                this.form.address1.value,
                this.form.address2.value,
                this.form.city.value,
                this.form.state.value,
                this.form.postcode.value,
                this.form.country.value
            )
            .then((response) => {
                // Add address to store
                this.$store.dispatch('user/setUpdateAddress', response.data)

                // Display snackbar
                const val = {
                    text: this.$t('snackbar.editAddressSuccess'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)

                this.isAddAddressBtnDisabled = false

                // Redirect
                this.$router.push('/dashboard/address')
            })
            .catch((error) => {
                if (error.response.status === 401) {
                    return
                }

                // Get errors object
                const errors = error.response.data.errors

                // Get keys of error
                const errorKeys: string[] = Object.keys(errors)
                const formKeys: string[] = Object.keys(this.form)

                // Set error messages
                for (const errorKey of errorKeys) {
                    for (const formKey of formKeys) {
                        if (this.form[formKey].requestKey === errorKey) {
                            this.form[formKey].error = errors[errorKey].reduce(
                                (message = '', currentMessage: string) => {
                                    return message + ' ' + currentMessage
                                }
                            )
                        }
                    }
                }

                // Reopen button
                this.isAddAddressBtnDisabled = false
            })
    }

    // Rules
    requiredRules(v: string) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    // Methods
    goToPage(id: Number) {
        switch (id) {
            case this.menus.ADDRESS.id:
                this.$router.push(this.menus.ADDRESS.path)
                break

            default:
                this.$router.push('/')
                break
        }
    }

    mounted() {
        if (typeof this.$refs !== 'undefined') {
            this.ref = this.$refs
            this.pageLoaded = true
        }
    }

    created() {
        this.$store.dispatch('menu/selectDashboardMenu', this.selectedPage)
        this.selectedAddress = parseInt(this.$route.params.slug)
        this.$store.dispatch('user/setEditAddress', this.selectedAddress)

        // Set existing value to form
        this.form.firstName.value = this.getAddress.firstName
        this.form.lastName.value = this.getAddress.lastName
        this.form.mobile.value = this.getAddress.mobile
        this.form.company.value = this.getAddress.company
        this.form.address1.value = this.getAddress.address1
        this.form.address2.value = this.getAddress.address2
        this.form.postcode.value = this.getAddress.postcode
        this.form.city.value = this.getAddress.city
        this.form.state.value = this.getAddress.state
        this.form.country.value = this.getAddress.country
    }
}
</script>
